% Example of 

clear;
clc;
close all;

figureIndex=1;
%ns = 100; % number of elements in the binary sequence
%nLevels=4; % number of levels
%maxAmplitude=1; %maximum amplitude of the signal

%STEP 1: Loads an input signal


load inputSignal.mat
t_original=linspace(0,1,length(inputSignal));

%STEP 2: Samples the input signal and obtains a sequence of samples

sampledSignal=zeros(1,length(inputSignal));
samplingPeriod=100;
ns=floor(length(inputSignal)/samplingPeriod);
for i=1:ns
    seq(i)=inputSignal((i-1)*samplingPeriod+1);
    sampledSignal((i-1)*samplingPeriod+1)=seq(i);
end

figure(figureIndex)
plot(linspace(0,1,length(inputSignal)),inputSignal)
hold on
pause
stem(linspace(0,1,length(inputSignal)),sampledSignal,'r')
figureIndex=figureIndex+1;
pause
lseq=length(seq);
pxp = 100; % oversampling ratio
Tl = (samplingPeriod/length(inputSignal));
fl = 1/Tl; % sample rate

%tseq = pxp*(lseq-1) + 1;
tseq = samplingPeriod*ns;%length(inputSignal);

responseDuration = linspace(-6*Tl,6*Tl,6*2*pxp);
roll_off = 0;

noiseBandwidth=(fl/2)*(1+roll_off);

%STEP 3: Creates a sequence of Dirac pulses with amplitude given by the
%above symbols, and convolves the Dirac train with a raised cosine impulse response

[pulses, Asum,figureIndex] = pulseGenerator (seq, fl, samplingPeriod, roll_off, responseDuration,tseq,figureIndex); % generates the sequence of pulses and the complete signal
totalLength=length(responseDuration)+tseq-1;%(pxp/samplingPeriod)*length(inputSignal)+1100;

    Asum=Asum*(max(inputSignal)/max(Asum));
t_final=linspace(-7*Tl*(pxp/samplingPeriod),1+5*Tl*(pxp/samplingPeriod),totalLength);
pause
figure(figureIndex)
figureIndex=figureIndex+1;
plot(t_original,inputSignal,'LineWidth',2)
axis([0 1 min(inputSignal),max(inputSignal)])
hold on
pause
%figure(figureIndex)
%figureIndex=figureIndex+1;
plot(t_final,Asum,'--r','LineWidth',2)
axis([t_final(1) t_final(end) min(Asum) max(Asum)])

% %STEP 3: Breaks the resulting signal in segments in order to build the eye
% %diagram, taking into account the impact of noise and path loss
% 
% numSegments = floor(length(Asum)/leye);
% noiseOn =1; %Flag for the introduction of thermal noise
% AdB=0; %Amplitude loss affecting the signal (applied in presence of noise), expressed in dB
% 
% eye_gen = zeros(numSegments,leye);
% eye_rx = zeros(numSegments,leye);
% 
% figure(figureIndex)
% figureIndex=figureIndex+1;
% hold on
% grid on
% for slidingIndex=1:(numSegments-(length(responseDuration))/leye)
%         eye_gen(slidingIndex,:)=Asum(1 + (slidingIndex+(length(responseDuration)/2)/leye-1)*leye:(slidingIndex+(length(responseDuration)/2)/leye)*leye);
%         if noiseOn
%             eye_rx(slidingIndex,:)= noiseSet(eye_gen(slidingIndex,:),noiseBandwidth, AdB);
%         else
%             eye_rx(slidingIndex,:)= eye_gen(slidingIndex,:); 
%         end
%         
%         
% %STEP 4: Draws the eye diagram
% 
%         plot(eye_window,eye_rx(slidingIndex,:))
% end
% if noiseOn
%     titleStr=sprintf('Eye diagram (L=%d, numSymbols=%d, A_{dB}=%3.2f dB)\n',nLevels,ns,AdB);
% else
%     titleStr=sprintf('Eye diagram (L=%d, numSymbols=%d)\n',nLevels,ns);
% end
% title(titleStr)
% xlabel('Time (s)')
% ylabel('Amplitude (V)')